#ifndef DataArrayMatlabH
#define DataArrayMatlabH


#ifdef __cplusplus
extern "C"
{
#endif

#define MAXITEMS (337+3)    // 340: max aggregate channels (DataRiver)
struct TDArray
{
	long nMaxItems;
	long nItems;
	long ItemSize;
	long TimeStampOrig;
	long TimeStampDest;
	long TimeCorrection;
	long UserData[2+8]; // 44 bytes
	long MaskIs24[16]; // 16 * 32 = 512 bits (max.ch)
	long Data[MAXITEMS];
	long Reserved;
};


//---------------------- Reading from buffer ---------
 
	void * ds_OpenRead   (char * mmfId);
	DWORD  ds_Peek	     (void * hr, TDArray * buf);       // return size(in bytes) and data in *buf, 0 if empty, does not move tail
	DWORD  ds_PeekPtr    (void * hr, TDArray * * bufaddr); // return size(in bytes) and data adddress in *bufaddr, 0 if empty, does not move tail
	DWORD  ds_Read       (void * hr, TDArray * buf);       // return size(in bytes) and data in *buf, 0 if empty
	DWORD  ds_ReadPtr    (void * hr, TDArray * * bufaddr); // return size(in bytes) and data adddress in *bufaddr, 0 if empty
	void   ds_CloseRead  (void * hr);
	int    ds_TailIs     (void * hr);
	void   ds_ResetTail  (void * hr);
	void * ds_HandleIs   (void * hr);
	DWORD  ds_NodesToRead(void * hr);
	DWORD  ds_TailPos    (void * hr);
	DWORD  ds_HeadPos    (void * hr);


//---------------------- Writing to buffer -----------------------
	void * ds_OpenWrite  (char * name, int nodesize,int freq);
	void   ds_CloseWrite (void * hw);
	DWORD  ds_Write      (void * h,TDArray *  data, int size); // returns head position


//-------------------- Utility func.  ----------------------------

	char * ds_GetParamPtr(void * hw); //typecast to TADParams *. NOTE: use handle returned by ds_OpenWrite or ds_HandleIs(hr)!
	int    ds_TimestampMs(void);


#ifdef __cplusplus
}
#endif

#endif


