function varargout = mocap_vr_calibration_gui(varargin)


% MOCAP_VR_CALIBRATION_GUI M-file for mocap_vr_calibration_gui.fig
%      MOCAP_VR_CALIBRATION_GUI, by itself, creates a new MOCAP_VR_CALIBRATION_GUI or raises the existing
%      singleton*.
%
%      H = MOCAP_VR_CALIBRATION_GUI returns the handle to a new MOCAP_VR_CALIBRATION_GUI or the handle to
%      the existing singleton*.
%
%      MOCAP_VR_CALIBRATION_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MOCAP_VR_CALIBRATION_GUI.M with the given input arguments.
%
%      MOCAP_VR_CALIBRATION_GUI('Property','Value',...) creates a new MOCAP_VR_CALIBRATION_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mocap_vr_calibration_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mocap_vr_calibration_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mocap_vr_calibration_gui

% Last Modified by GUIDE v2.5 06-Apr-2010 17:39:44

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @mocap_vr_calibration_gui_OpeningFcn, ...
    'gui_OutputFcn',  @mocap_vr_calibration_gui_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mocap_vr_calibration_gui is made visible.
function mocap_vr_calibration_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to mocap_vr_calibration_gui (see VARARGIN)

% Choose default command line output for mocap_vr_calibration_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes mocap_vr_calibration_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = mocap_vr_calibration_gui_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in newSpherePushbutton.
function newSpherePushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to newSpherePushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global mr;
mr.mocap.waitingForObjectCalibrationOfType = 'vrSphere';
mr.mocap.numberOfCalibrationPointsNeeded = 2;
mr.mocap.calibrationPoints = [];
mr.mocap.calibrationGuiHandles = handles;

% disable both new object push buttons after adding a new calibrated object
% is requested.
set(handles.newBoxPushbutton, 'Enable', 'off');
set(handles.newSpherePushbutton, 'Enable', 'off');

% add some text to the log
currentLogText= get(handles.prompt, 'String');
newText = 'Adding a new Sphere, waiting for two (2) calibration points on two opposite sides of the sphere.'; 
set(mr.mocap.calibrationGuiHandles.prompt, 'String', newText);

% --- Executes on button press in newBoxPushbutton.
function newBoxPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to newBoxPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global mr;
mr.mocap.waitingForObjectCalibrationOfType = 'vrBox';
mr.mocap.numberOfCalibrationPointsNeeded = 5;
mr.mocap.calibrationPoints = [];
mr.mocap.calibrationGuiHandles = handles;

% disable both new object push buttons after adding a new calibrated object
% is requested.
set(handles.newBoxPushbutton, 'Enable', 'off');
set(handles.newSpherePushbutton, 'Enable', 'off');

% add some text to the log
currentLogText= get(handles.prompt, 'String');
newText = 'Adding a new Box, waiting for five (5) calibration points. First four (4) points specify the base and the last point sets Box height.'; 
set(mr.mocap.calibrationGuiHandles.prompt, 'String', newText);

function editLabel_Callback(hObject, eventdata, handles)
% hObject    handle to editLabel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editLabel as text
%        str2double(get(hObject,'String')) returns contents of editLabel as a double


% --- Executes during object creation, after setting all properties.
function editLabel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editLabel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to log (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of log as text
%        str2double(get(hObject,'String')) returns contents of log as a double


% --- Executes during object creation, after setting all properties.
function log_CreateFcn(hObject, eventdata, handles)
% hObject    handle to log (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over newSpherePushbutton.
function newSpherePushbutton_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to newSpherePushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

global mr;
mr.mocap.objectCollection = vrObjectCollection;

% set figure background color similar to EEGLAB
icadefs;
set(hObject,'color', GUIBACKCOLOR);


% --- Executes on button press in save.
function save_Callback(hObject, eventdata, handles)
% hObject    handle to save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


global mr;
objectCollection = mr.mocap.objectCollection;

% save objectCollection which contains the data necessary to re-create
% calibrated objects
uisave('objectCollection','calibratedObjectCollection.mat');
