function mr_spectrum_ball(doReset)

if nargin<1
    doReset = false;
end;

global mr

persistent myworld ballNode figureHandle;


comp = 1;


if isempty(myworld) || doReset
    myworld = vrworld('vrbounce.wrl');
 %myworld = vrworld('vrtkoff_hud.wrl');

    open(myworld);
    
    
    figureHandle = view(myworld);
    vrdrawnow;
    
    ballNode = vrnode(myworld, 'Ball');
  %  ballNode = vrnode(myworld, 'Plane');
end;

if mr.numberOfFramesInAccumulatedData < mr.samplingRate
    return;
end;

[tf, freqs, times] = timefreq_silent(mr.eeg.icActivity(comp,:)', mr.samplingRate, 'freqs', 10,'nfreqs',1);
power = abs(tf);

ballNode.translation = [0 mean(power(end-5:end)) 0];

vrdrawnow;

end
