function mr_eeg_ocean_cortex

global mr

persistent figureHandle fsfVertextDistanceToDipole numberOfColorsInTheColormap colorMapIsHasNegative

icIndexNumber = [1 2]; % index of ic in requested ics

eegFrameToCortextDistanceRatio = 3;

if isempty(figureHandle) || ~ishandle(figureHandle) || ~ishandle(axisHandle)
    
    
    
    fsf = load('/home/nima/tools/eeg/MNImesh_dipfit.mat');
    
    figureHandle = figure;
    fsfHandle = plotmesh(fsf.faces, fsf.vertices, [], false);
    
    set(gcf,'Renderer' ,'opengl');
    reducepatch(fsfHandle, 1/8);
    
    % simple gaussian projection on surface
    
    gaussianStd = 2;
    
    fsfVertices = get(fsfHandle(1), 'Vertices');
    clear diplePosition fsfVertextDistanceToDipole
    diplePosition{1} = EEG.dipfit.model(17).posxyz;
    diplePosition{2} = EEG.dipfit.model(25).posxyz;
    
    clear projection ;
    for i=1:length(diplePosition)
        fsfVertextDistanceToDipole(i,:) = sum( (fsfVertices - repmat(diplePosition{i}, size(fsfVertices, 1), 1)) .^2, 2) .^ 0.5;
        projection(i,:) = exp((-1/(2*gaussianStd^2)) *fsfVertextDistanceToDipole(i,:));
    end;
    
    dipoleProjectionOnAllCortext = projection;
    %
    % set the appropriate colormap
    load('/home/nima/tools/cortex_viz/cortex_gray_colormap_with_only_warm_colors');
    load('/home/nima/tools/cortex_viz/cortex_gray_colormap_with_in_jet_middle.mat');
    
    colorMapIsHasNegative = false;
    
    if colorMapIsHasNegative
        set(figureHandle, 'colormap', cortexGrayWithOnlyWarmColors);
    else
        set(figureHandle, 'colormap',cortexGrayInMiddleOfJet);
    end;
    
    numberOfColorsInTheColormap = length(get(gcf,'Colormap'));
   
end;


activityToPlot = abs(hilbert(mr.eeg.icActivity(1,:)));

totalDipoleProjection = 0;
for i=1:length(diplePosition)
    totalDipoleProjection =  totalDipoleProjection + activityToPlot(max(1, round(end - fsfVertextDistanceToDipole(i,:)*3)));
end;

if colorMapIsHasNegative
    maxAbsProjection = max(abs(totalDipoleProjection));
    adjustedTotalDipoleProjectionOverAllFrames = 0.5 * totalDipoleProjection / maxAbsProjection; % map the max value to 0.5
    colorValue =  (adjustedTotalDipoleProjectionOverAllFrames+ 0.5) * (numberOfColorsInTheColormap);
else
    adjustedTotalDipoleProjectionOverAllFrames = totalDipoleProjection / max(totalDipoleProjection);
    colorValue =  adjustedTotalDipoleProjectionOverAllFrames * (numberOfColorsInTheColormap);
end;

set(fsfHandle, 'CDataMapping','direct')
set(fsfHandle, 'Cdata', colorValue);
set(fsfHandle, 'FaceColor','interp');
