function VR_force_plate_visualize(force, moment)

persistent figureHandle FPworld momentHandle arrowHandle forceHandle textforceHandle textmomentHandle force_cord moment_cord
%mrot_zero mscale_zero frot_zero fscale_zero
%forceArrowHandle momentArrowHandle placeHgTransform forceScale momentScale momentVectorScale axisHandle;

if isempty(figureHandle) || ~isvalid(figureHandle)
    
    % Initialize VRworld for vizualization of Force Platform
    FPworld = vrworld('C:\Users\Sarmaji\Documents\MATLAB\vr_force_plate.WRL');
    open(FPworld);
   
    % set up the figure
    figureHandle = vrfigure(FPworld);

    %Establish transforms (based on vr nodes)
    momentHandle = vrnode(FPworld, 'plate_and_arrow_transform');
    arrowHandle = vrnode(FPworld, 'arrow_transform');
    forceHandle = vrnode(FPworld, 'force_transform');
 
    % Add labels
    force_cord = [-4 13.00 6];
    moment_cord = [0.0044 15.8893 0.000];
    vr_add_text_billboard(FPworld, force_cord, 'Force', 5);
    vr_add_text_billboard(FPworld, moment_cord, 'Moment', 5);
    textforceHandle = vrnode(FPworld, 'text_outer_transform1');
    textmomentHandle = vrnode(FPworld, 'text_outer_transform2');
   
%     % Save initial conditions
%     forceHandle.rotation = momentHandle.rotation;  
    
end;
 

  
  % Scaling Factors
  momentScale = 1/ 2000;
  forceScale = 1/ 900;
  momentVectorScale = 1/ 700; 

  
  % force arrow orientation - remeber that xyz matlab is xzy in vr
  zAngle=atan2(force(3), force(1)); 
  yAngle=atan2(force(2), force(1));
  xAngle=atan2(force(2), force(3));
  rotationMatrix = makehgtform('yrotate', yAngle, 'zrotate',zAngle, 'xrotate', xAngle); %
  ft = rotationMatrix;
  fm = [ft(1) ft(5) ft(9); ft(2) ft(6) ft(10); ft(3) ft(7) ft(11)];
  fr = vrrotmat2vec(fm);
  forceHandle.rotation = fr;
  
  % force arrow scale
  Force_amp = forceScale*norm(force, 'fro');
  Force_mag = [1 Force_amp 1];
  forceHandle.scale = Force_mag;

  %Move Force text
   textfr = force_cord * fm';
   textforceHandle.translation = textfr;
%   textforce_trans = textforceHandle.translation;
%   textfr = textforce_trans * fm'

%   xf = Force_amp*sin(xAngle);
%   yf = Force_amp*sin(yAngle);
%   zf = Force_amp*sin(zAngle);
%   textforceHandle.translation = [xf yf zf];

%   if abs(xf)>abs(yf) && abs(zf)> abs(yf)
%       textforceHandle.translation = [5+xf yf 5+zf];
%   elseif abs(xf)>abs(zf) && abs(yf)> abs(zf)
%       textforceHandle.translation = [5+xf 5+yf zf];
%   elseif abs(zf)>abs(xf) && abs(yf)> abs(xf)
%       textforceHandle.translation = [xf 5+yf 5+zf];
%   end;

   
  % moment orientation (force platform tilt)
  rotationMatrix = makehgtform('xrotate', moment(1) * momentScale, 'yrotate', moment(3) * momentScale,'zrotate', moment(2) * momentScale);
  t = rotationMatrix;
  m = [t(1) t(5) t(9); t(2) t(6) t(10); t(3) t(7) t(11)]; %Need to find better way to extract from 4x4 matrix to 3x3
  r = vrrotmat2vec(m);
  momentHandle.rotation = r;
  
  % moment arrow scale
  Moment_amp = momentVectorScale*norm(moment, 'fro');
  Moment_mag = [1 Moment_amp 1];
  arrowHandle.scale = Moment_mag;  %moment or arrow.scale
  
  %Move Moment text
  textmr = moment_cord * m';
  textmomentHandle.translation = textmr;
%   textmomentHandle.translation = momentHandle.rotation;
%   zmAngle=atan2(moment(2), moment(1)); 
%   ymAngle=atan2(moment(3), moment(1));
%   xmAngle=atan2(moment(3), moment(2));
%   xm = Moment_amp*sin(xmAngle);
%   ym = 16 + Moment_amp*sin(ymAngle);
%   zm = Moment_amp*sin(zmAngle);
%   textmomentHandle.translation = [xm ym zm];

  
 pause (0.16)
% forceHandle.rotation = fr; forceHandle.scale = Force_mag; momentHandle.rotation = r; arrowHandle.scale = Moment_mag;
%   delete(lastforceHandle);
%   delete(lastmomentHandle);
%   delete(lastarrowHandle);
%   vrdrawnow;

end
