%------------------------------------------------------------
%   Start-up script for DataSuite / Matlab interfacing:
%------------------------------------------------------------
%   Files needed:
%   The starting folder:
%       open_ds.m (this file)
%       data_river.dll
%       ds_matlab.h     - all in the same (main) directory;
%       folder /m (below the starting folder)
%               - contains matlab scripts and functions.
%               
%   
%   Logical order:
%   1.  Run this script to open DataSuite library (data_river.dll).
%       from the starting folder. This adds the paths to bothe folders
%       to 'path', opens the DataSuite library and returns two global
%       variables:
%       ds_lib: used by all m/ds_ functions to call library functions;
%       ds_array:   the structure used to exchange data with the DataRiver
%                   streams.
%       
%   2.  Call h=ds_Open..... function to open a DataRiver stream. 
%   3.  Use the returned handle (h) to call the necessary ds_ functions 
%       to write data to or read data from the stream.
%   4.  When finished, call the corresponding ds_Close... function,
%       passing the handle h as parameter to close the stream.
%------------------------------------------------------------

w = what('.');
ds_dir = w.path(1:end-2);
addpath(ds_dir)
dsm_dir = strcat(ds_dir,'\m');
addpath(dsm_dir)
global ds_lib
global ds_array
global ds_array_size
[ds_lib,ds_array,ds_array_size]=open_ds_lib;

